Bug 44779 - Using commas and semicolons for content negotiation instead of file extensions
Summary: Using commas and semicolons for content negotiation instead of file extensions
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_negotiation (show other bugs)
Version: 2.2.6
Hardware: PC Linux
: P2 enhancement (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2008-04-08 07:00 UTC by Da’an
Modified: 2018-11-07 21:09 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Da’an 2008-04-08 07:00:32 UTC
Hi,

urn:ietf:rfc:3986 says to use commas and semicolons instead of dots when dealing with things such as content negotiation. (Actually, it does not say that at all; but it is the point of that RFC.)

Look at this example where all bits of information used in the negotiation process for ../resource is separated with dots.

../resource.en.utf-8.xhtml.gz

Then look at this example where all the keys but the actuall file extension---though note that the example has two extensions---are separated with commas instead.

../resource,en,utf-8.xhtml.gz

Another approch form urn:ietf:rfc:398 is to use semicolon and value--key pairs. Again, note that the file has two extensions realted to format.

../resource;lang=en;encoding;utf-8.xhtml.gz

Both methods allow for negotiation matching a file path AND for negotiation that does not match the file path exactly. For example would both the below example still match the correct file because the information is properly separated from the both the file name and file extension.

../resource;encoding;utf-8;lang=en.xhtml.gz
../resource,utf-8,en.xhtml.gz

...I really hope this will be implemented soon. Ths would clean up all the messy URIs of the world in an instance. (Well, at least it would prevent new URIs from being dirty.)
Comment 1 Da’an 2008-04-09 05:07:33 UTC
I am intending this for the MultiViews negotiation method. In shorthand, what I want is for the multiviews method to support periods, commas, and semicolons.

../resource,en.htm
../resource,en.xht
../resource,de.htm
../resource,de.xht
Comment 2 William A. Rowe Jr. 2018-11-07 21:09:10 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.